![imagebanner](https://cdn.discordapp.com/attachments/817828391662649366/1107520747682938910/IW.png)

### The Infinite Warfare Collection

Shoutouts to Tyconson, aka Widepeepoclappy, for being an even bigger fan of Infinite Warfare than I am.

Big props to Yung for the early beginnings of the COD Ftrmarket collection, the first few guns were made thanks to his help. 

Bless Kirloper for the huge repo of IW assets, allowing for easier implementation when all the resources are in one place.

Big thanks to Kuromi for the assist in regards to SFX, alongside tiktokfamous for giving me pointers on how to use the SAB extractor in order to gather my own audio collection of IW sfx. Also should mention the occassional check-in to Skye's audio repo, thank you to PLOOF for directing me there.

---

### Background

Infinite Warfare. Remarked as an example of tone-deafness, it's reveal trailer was meme'd upon when it was compared side by side with Battlefield 1, the competitive release within the same year. "Yet another jetpack shooter" is what it was summed up to, before the game had ever released. With Modern Warfare Remastered shoe-horned in there, perhaps they anticipated such backlash and cushioned the blows by appealing to a nostalgic crowd.

And yet, for all that its worth, I weigh the space based Call of Duty above all else. I had participated in the game late, as a Christmas noob, and was minimally exposed to how the public felt about the game post-launch. I chose to participate in Battlefield 1 on their first day rather than Infinite Warfare, and remember being underwhelmed by the game's offerings at the time. To me, I had desired an arcade shooter that had substance to it, and boy Infinite Warfare was just that.

Having skipped Advanced Warfare, Infinite Warfare's campaign with its focus on cinemotography, a movie-esk narrative, and focusing on character development that wasn't mere one-liners or badass moments, it is regarded as one of the best campaign experiences COD can offer. Given the opportunity to reach for the literal stars and otherworldly scenarios sure does help in that regard.

Multiplayer, the third take on jetpacks, the gunplay, movement, and right-back-to-the-action overall experience not only lasts the test of time as one of my favorite core multiplayer experiences, but was the precursor to a formula known as movement shooters, a hybrid of arena shooters and arcade aspects solely focused on keeping your speed and out manuevering the competition. It was a beautiful blend, in regards to IW, where the game had its compelling gameplay psyched enough to keep you playing for hours on end.

And lastly, Zombies. Hot take, what they provided here in terms of Zombies is unlike anything Treyarch has done before. If they didn't send off BO3 with Zombies Chronicles, Infinite Warfare's Zombies wouldn't be so hard to pick as my favorite. Zombies in Spaceland is the GOAT zombies experience if you want to have the maximum amount of fun in a Zombies game. Directors Cut and, oh my lord, all the boss fights you can partake in the zombies gamemode had implanted onto me my core philosophies when it comes to making Easter Eggs and rewarding people who participate in them. It is actually a known fact that people who came to play Infinite Warfare, stayed to play the zombies.

I can gush on and on about this game and how I love it, but I got to reel it back a little and discuss why we have IW's guns in H3VR.

---

### IW Weapons and H3VR, The History

So IW's weapon team went half kinetic, half economic. There are some guns which use bullets, while others use laser beams. Hell, there was [in-universe lore in regards to the gun manufacturers](https://www.gameinformer.com/b/features/archive/2016/06/22/lock-and-load-with-the-weapons-of-call-of-duty-infinite-warfare.aspx) of IW's guns. This was the first instance of them pushing these such gun characteristics, and later games would all have their own in-lore gun companies, even MW '22 has these fake manufacturers labeled with real firearms. If you play MW '22, do the names Cronen, Tempus, and XRG come into mind? To me, have fictional firearms with fictional manufacturers is more effective than having real firearms with fictional manufacturers. Just saying.

Anyways, in regards to H3, I wasn't the first to implement Infinite Warfare firearms into this game. I was beaten in that regard by two other Modmakers, Tyconson67 (Widepeepoclappy) and AndrewFTW.

Andrew was the first. He implemented the UDM-45 in his own way. The core implementation had no flaws, and he did go above and beyond there with the built in flashlight and reflex optic... But there was no respect for the source material. A four round burst, stock H3 sfx, no fanfare of where it came from... I couldn't say for certain whether or not he did play the game, but I started to feel less likely not. Most important of all, the reason why I will not include his UDM in this pack is because it is a deli mod, and that comes with risks of entire profile corruptions. He has not stepped up to convert his mods into Stratum mods, and it is more than likely going to be me making my own UDM then to expect him to change his up...

Tyconson was on the other side of the spectrum. He was faithful to the source material, in fact he is stupendously headstrong to it. Being in charge of wiki development, including Infinite Warfare's wiki page, his hands-on approach on gather IW assets himself really pushed me to get better at implementing guns. He even banked on matching IW guns down to their variant's attributes, like the Windfall with its health regen properties, the eccentric wishlist he had blew my mind to say the least. However, the FHR40 in itself was still his first project, and there were a lot of back n' forths on getting it to where it was, and there is always room for improvements as well. Sadly, his computer being out of commission means that it will be a while before we see the next best thing he has in mind, if he still shows interest in modding H3.

And then I pull the light back to me. My implementations are not perfect. From blemishes to creative liberties, I have sinned in both departments, the scrutiny won't be one sided. However, the process to implement these guns is no cakewalk either, and explaining that would help explain why these things occur.

---

### IW Weapons and H3VR, Their Compatibility

Infinity Ward like to compress their textures, CS and NOG style. CS being an RGB / Alpha relationship, NOG being a three way compression of Normal, Occlusion, and Gloss.

Being a wee slow, I hadn't learned that GameImageUtil was a thing, my first iterations made an attempt to use the CS file as the color, and the NOG file as the normal file... How wack of me to do that.

But, even more frustrating (and even more frustrating of not knowing how to remedy this) was how deeply embedded the meshes were. The methods of using L and P to split meshes were not optimal in this case, and doing splitting by hand was in equal parts a chore alongside dangerous. The blemishes I have on the Trek 50 and the Titan make this very much apparent.

Thankfully, texture sets are far milder compared to the 3Arch counterparts, anywhere between 2 and 7 sets of textures makes it more approachable for an implementer to use. The model again, however, has to give lip by having separate materials for dupe textures, resulting in inconsistencies between Substance Painter and Blender, just like BO4 models.

I've learned this bit at the latest moment, the Base Color label of the model also acts as a beacon to help match parts together with the same material. This has to be done by hand in Blender, before you delete the base color data and proceed to work on the textures in SP. Or, you can work with them in material map channel packer, since Infinity Ward doesn't use the Ximage / Xmaterial madness that BO4 / BOCW does, you could match textures to the channel packer.

To wrap this segment up, a whole division of various "Energy Bullets" was made to accomodate the battery powered weapons of this game. No Meshes, the ejection points are transposed deep below the weapon, to give the illusion that the weapons are their own form of "caseless". This energy bullet system was revised when Meatkit became a thing, the no mesh feature coming soon after. The Space Race Advent Calendar gave it the shotgun variant of energy bullets, too, which in itself will need further revision as the bullet mesh hasn't been disposed of yet.

IW weapons will always be a work in progress it seems...

---

![imagegif](https://cdn.discordapp.com/attachments/817828391662649366/1107520283759362098/IWModpack.gif)

### The IW Weapon List (* For skin related releases, ** For other mod author releases)

Submachine Guns -- ERAD, FHR-40**, HVR, Raijin-EMX

Assault Rifles -- NV4, R3K (+ R3KT), KBAR-32, Volk, G-Rail

Tac Rifles -- Auger DMR, ABR-223, Swordfish, S6 Stingray

Shotguns -- DCM-8, Reaver, M. 2187

Light Machine Guns -- Titan, Atlas*

Sniper Rifles -- KBS Longbow*, EBR-800, Widowmaker, Trek-50, Proteus

Pistols -- EMC, Oni, Hailstorm (Ordnance)

A healthy roster of weapons from IW, the same issues as BO3 where the difficulty spikes in trying to capture the guns entire character, from its functions to its quirks. Above 75% complete with this roster, a few strays away from completion. Hoping that putting this into perspective fires someone up to make their own to-do list of weapons to implement.

---

### Sources and Credits

The weapons featured in this modpack belong to the game Call of Duty, Infinite Warfare, Infinity Ward and Raven being the devs, Activision owning the studios.

Implementation with my weapons was possible thanks to both Yung and Kirloper, thank you guys for your amazing support.

Thank you again to Kuromi for helping out with SFX gathering, too!

### Updates

V0.9.9 -- Initial Release, pre-Space Race upload. V1.0.0 will come moments after H3VR's experimental branch goes to the main branch, the delay due to needed scripts required for select Space Race firearms!